extends ../../includes/layout

block content
    style. 
        .btn-w{
            width:95px;
        }

        .r-15{
            margin-right:15px;
        }
    .d-flex.align-items-center.mb-4
        h4.fs-20.font-w600.mb-0.me-auto #{nav}
    .row
        .col-xl-12
            .card
                .card-body
                    .row
                        .col-sm-12
                            h3
                                button.btn.btn-sm.btn-rounded.l-5.btn-info#btn_pause_all Pause All
                                button.btn.btn-sm.btn-rounded.l-5.btn-info#btn_start_all Start All
                                button.btn.btn-sm.btn-rounded.l-5.btn-info#btn_reset_all Reset All
                            table#pickle.table.table-hover.table-striped.table-bordered
                                thead
                                    tr
                                        th #
                                        th Name
                                        th Status
                                        th Start
                                        th Max Round
                                        th Round
                                        th Count Down Start
                                        th Count Down End
                                        th 

                                tbody

        #modal_setting.modal.fade(tabindex='-1' aria-labelledby='modal_setting_label' data-backdrop="static" data-keyboard="false")
            .modal-dialog.modal-lg
                .modal-content
                    .modal-header
                        h5#modal_setting_label.modal-title History
                        button.btn-close(type='button' data-bs-dismiss='modal' aria-label='Close')
                    .modal-body
                        #myhistory
                        #myconfirm(style="display:none;border-style: solid;padding: 5px;margin: 5px 207px;text-align: center;")
                            h4 Are you sure ?
                            p#setting_detail
                            button.btn.btn-light.btn-sm#btn_close_setting(type='button') Close
                            button.btn.btn-danger.btn-sm.l-5#btn_confirm_setting(type='button') Confirm

                    .modal-footer
                        button.btn.btn-light.btn-sm#btn_close_setting_modal(type='button' data-bs-dismiss='modal') Close
block script
    script(src='/socket.io/socket.io.js')
    script.
        var socket = io();
        var products = [];
        var start_count = false
        var countdown = {}
        var setting = {}

        list_lot();

        $('#btn_close_setting_modal').click(function(){
            setting = {}
            console.log(setting)
            $('#myconfirm').hide()
        })

        $('#btn_close_setting').click(function(){
            setting = {}
            console.log(setting)
            $('#myconfirm').hide()
        })

        $('#btn_confirm_setting').click(function(){
            console.log(setting)

            $.ajax({
                url: "#{base_url}admin/auctioneer/reset_round",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    id:setting.id,
                    key:setting.key,
                    round:setting.round,
                    user_id:user_id
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        console.log(setting)
                        products[setting.key]['round_slug'] = res.round_slug
                        products[setting.key]['status'] = res.status
                        products[setting.key]['pause'] = res.pause
                        products[setting.key]['count_down_round'] = res.product.round_countdown
                        console.log(products)

                        $('#status_'+res.product._id).text(products[setting.key]['status'])
                        $('#round_slug_'+res.product._id).text(res.round_slug)
                        $('#count-down-'+res.product._id).text(res.product.round_countdown)

                        var btn_pause = $('#pickle #btn_pause_'+res.product._id);

                        if(btn_pause.text()=='pause'){
                            btn_pause.removeClass('btn-info')
                            btn_pause.addClass('btn-danger')
                            btn_pause.text('start')
                        }

                        btn_pause.prop('disabled', false);

                        socket.emit('countdown', res.product.round_countdown);

                        socket.emit('count_room', res.product._id,res.product.round_countdown,res.round_slug);

                        setting = {}
                        console.log(setting)

                        $("#modal_setting").modal("hide")

                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }

                },
            });
        })

        $('#myhistory').on('click','.btn_reset_round',function(){
            const obj = $(this)
            const round = obj.attr('data-round')
            const id = obj.attr('data-id')
            const key = obj.attr('data-key')

            setting = {
                round:round,
                id:id,
                key:key
            }

            $('#setting_detail').text('Reset round '+round)
            $('#myconfirm').show()

            socket.emit('reset', id)

        })

        $('#pickle tbody').on('click','.btn_setting',function(){
            $('#myhistory').empty();
            var obj = $(this)
            var id = obj.attr('data-id')
            var key_product = obj.attr('data-key')
            $.ajax({
                url: "#{base_url}admin/auctioneer/get_product",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    id:id,
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        console.log(res)

                        setting = {}
                        console.log(setting)
                        $('#myconfirm').hide()
                        $(res.data.rounds).each(function(key,val){
                            let = disabled = ''
                            if(key==0){ 
                                disabled = 'disabled'
                            }   
                            var date = moment(val.created_at).format('YYYY/MM/DD HH:mm:ss')
                            var reset = '<button '+disabled+' class="btn btn-sm btn-rounded r-15 btn-danger btn_reset_round btn-w" data-id="'+id+'" data-round="'+val.round+'" data-key="'+key_product+'">Reset</button>';
                            $('#myhistory').append('<p>'+reset+' Round : <b>['+val.round+']</b> '+val.detail+' '+date+'</p>');
                        })
                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }

                },
            });
            $("#modal_setting").modal("show");
        });

        $('#btn_start_all').click(function(){
            swal({
                title: "Are you sure?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: 'Yes, I am sure!',
                cancelButtonText: "No, cancel it!"
            }).then(function(result) {
                if(result.value){
                    start_all()
                }
            })
        });

        function start_all(){
            $.ajax({
                url: "#{base_url}admin/auctioneer/start_all",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    result:true,
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        list_lot()
                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }

                },
            });
        }

        $('#btn_pause_all').click(function(){
            swal({
                title: "Are you sure?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: 'Yes, I am sure!',
                cancelButtonText: "No, cancel it!"
            }).then(function(result) {
                if(result.value){
                    pause_all()
                }
            })
        });

        function pause_all(){
            $.ajax({
                url: "#{base_url}admin/auctioneer/pause_all",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    result:true,
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        list_lot()
                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }

                },
            });
        }

        $('#btn_reset_all').click(function(){
            swal({
                title: "Are you sure?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: 'Yes, I am sure!',
                cancelButtonText: "No, cancel it!"
            }).then(function(result) {
                if(result.value){
                    reset_all()
                }
            })
        });

        function reset_all(){
            $.ajax({
                url: "#{base_url}admin/auctioneer/reset_all",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    result:true,
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        list_lot()
                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }

                },
            });
        }

        function change_status(id,status,key){
            $.ajax({
                url: "#{base_url}admin/auctioneer/change_product",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    result:true,
                    id:id,
                    status:status
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){

                        products[key]['pause'] = res.data.pause

                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }

                },
            });
        }

        $('#pickle tbody').on('click','.btn_pause',function(){
            var obj = $(this);
            var status = obj.text();
            if(status=='pause'){
                obj.text('start');
                obj.removeClass('btn-info');
                obj.addClass('btn-danger');
            }else if(status=='start'){
                obj.text('pause');
                obj.removeClass('btn-danger');
                obj.addClass('btn-info');
            }

            change_status(obj.attr('data-id'),status,obj.attr('data-key'));
        });

        $('#pickle tbody').on('click','.btn_reset',function(){
            var obj = $(this)
            var id = obj.attr('data-id')
            var key = obj.attr('data-key')
            swal({
                title: "Are you sure?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: 'Yes, I am sure!',
                cancelButtonText: "No, cancel it!"
            }).then(function(confirm) {
                if(confirm.value){
                    $.ajax({
                        url: "#{base_url}admin/auctioneer/reset_product",
                        headers: {
                            'Authorization': 'Bearer '+access_token,
                        },
                        method: "POST",
                        dataType: "json",
                        data:{
                            result:true,
                            id:id,
                            startPrice:products[key]['startPrice']
                        },
                        success: function (res, status, xhr) {
                            if(status=='success' && xhr.status==200 && res.result){
                                products[key]['round_slug'] = 0
                                products[key]['status'] = res.product.status
                                products[key]['pause'] = res.product.pause
                                products[key]['count_down_round'] = res.product.round_countdown

                                console.log(products)

                                $('#status_'+id).text(products[key]['status'])
                                $('#round_slug_'+id).text(res.product.round_slug)
                                $('#count-down-'+id).text(res.product.round_countdown)

                                var btn_pause = $('#pickle #btn_pause_'+res.product._id);
                                if(btn_pause.text()=='pause'){
                                    btn_pause.removeClass('btn-info')
                                    btn_pause.addClass('btn-danger')
                                    btn_pause.text('start')
                                }
                                btn_pause.prop('disabled', false);

                                socket.emit('countdown', res.product.round_countdown);

                                socket.emit('count_room', res.product._id,res.product.round_countdown,res.product.round_slug);

                                socket.emit('reset', id)
                            }else{
                                sweetAlert("Oops...", data.message, "error");
                            }
                        },
                        error: function (xhr, status, error) {
                            if(xhr.status==401){
                                redirect_login();
                            }else{
                                alert_message(xhr.responseText);
                            }

                        },
                    });
                }
            })

        });

        function addMinutes(date, minutes) {
            return new Date(date + minutes*60000);
        }

        function time_to_string(val){
            var d = new Date(val);
            return start = d.getDate() + '/' + (d.getMonth()+1) + '/' + d.getFullYear() + ' ' + d.getHours() + ':' + d.getMinutes() + ':' + d.getSeconds();
        }

        function component(x, v) {
            return Math.floor(x / v);
        }

        setInterval(function() {
            $.each(products, function( index, value ) {
                if(start_count){
                    if(value.status=='open'){
                        if(value.pause=='pause'){
                            set_countdown(index,value);
                        }
                    }     
                    if(value.status=='wait'){
                        time_start(index,value)
                    }
                }
            }); 
        }, 1000);

        function get_status_change(index,value){
            $.ajax({
                url: "#{base_url}admin/auctioneer/get_status_change",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    id:value._id,
                    status:status
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){

                        products[index]['status'] = 'open'
                        products[index]['pause'] = 'pause'
                        $('#status_'+value._id).text(fuper(res.data.status))

                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }
                },
            });
        }

        function set_countdown(index,value){
            var div = '#count-down-'+value._id
            var id = value._id

            if(products[index]['count_down_round']==0){

                products[index]['pause'] = 'process';

                $(div).text('process');

                $('#pickle #btn_pause_'+id).prop('disabled', true);

                $('#pickle #btn_reset_'+id).prop('disabled', true);

                $('#pickle #btn_setting_'+id).prop('disabled', true);

                countdown[id] = {
                    count:'process',
                    round:products[index]['round_slug'],
                    status:products[index]['status'],
                }

                socket.emit('countdown', countdown);

                socket.emit('count_room', id,'process',products[index]['round_slug']);

                update_round(index,value);
            }else{
                $(div).text(products[index]['count_down_round']);

               $('#pickle #btn_pause_'+id).prop('disabled', false);

                $('#pickle #btn_reset_'+id).prop('disabled', false);

                $('#pickle #btn_setting_'+id).prop('disabled', false);

                countdown[id] = {
                    count:products[index]['count_down_round'],
                    round:products[index]['round_slug'],
                    status:products[index]['status'],
                }

                socket.emit('countdown', countdown);

                socket.emit('count_room', id,products[index]['count_down_round'],products[index]['round_slug']);

                products[index]['count_down_round'] = products[index]['count_down_round'] -1;
            }
        }

        function update_round(index,value){
            $.ajax({
                url: "#{base_url}admin/auctioneer/process_round",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    result:true,
                    id:value._id,
                    round_slug:value.round_slug,
                    user_id:user_id,
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        products[index]['count_down_round'] = res.data.round_countdown
                        products[index]['pause'] =  res.data.pause
                        products[index]['round_slug'] = res.data.round_slug
                        products[index]['status'] = res.data.status
                        $('#round_slug_'+res.data._id).text(res.data.round_slug)

                        countdown[res.data._id] = {
                            count:res.data.count_down_round,
                            round:res.data.round_slug
                        }

                        socket.emit('countdown', countdown);

                        if(res.data.status == 'finish'){
                            $('#status_'+res.data._id).text("Finish")
                            $('#count-down-'+res.data._id).text("-")
                            $('#pickle #btn_pause_'+res.data._id).prop('disabled', true);
                        }
                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }
                },
            });
        }


        function time_start(index,value){
            var div = '#count-start-'+value._id
            var start = Date.now();
            var timez = Date.parse(value.date_start);
            var timestamp = timez - start;
            //var timestamp = (Date.now() + 1000 * 60 * 60 * 24 * 3) - Date.now();
            timestamp /= 1000; // from ms to seconds
            timestamp--; // decrement timestamp with one second each second

            var days    = component(timestamp, 24 * 60 * 60),      // calculate days from timestamp
                hours   = component(timestamp,      60 * 60) % 24, // hours
                minutes = component(timestamp,           60) % 60, // minutes
                seconds = component(timestamp,            1) % 60; // seconds

            if(timestamp<=0){
                var result = 'Start'
                update_status(index,value,'open')
            }else{
                var result = days + " days, " + add_zero(hours) + ":" + add_zero(minutes) + ":" + add_zero(seconds);
            }

            $(div).text(result);
        }

        function update_status(index,value,status){
            console.log('update_status_product')
            $.ajax({
                url: "#{base_url}admin/auctioneer/update_status_product",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    id:value._id,
                    status:status,
                    user_id:user_id
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){

                        products[index]['status'] = 'open'
                        products[index]['pause'] = 'pause'
                        $('#status_'+value._id).text(fuper(products[index]['status']))

                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    if(xhr.status==401){
                        redirect_login();
                    }else{
                        alert_message(xhr.responseText);
                    }
                },
            });
        }

        function add_zero(data){
            if((data.toString()).length==1){
                return '0'+data;
            }
            return data;
        }

        function list_lot(){
            start_count = false
            $.ajax({
                url: "#{base_url}admin/product",
                headers: {
                    'Authorization': 'Bearer '+access_token,
                },
                method: "POST",
                dataType: "json",
                data:{
                    result:true
                },
                success: function (res, status, xhr) {
                    if(status=='success' && xhr.status==200 && res.result){
                        var now = 0;
                        $('#pickle tbody').empty();

                        $(res.data).each(function(key,val){
                            console.log('loop');
                            var start = time_to_string(val.date_start);
                            var end = time_to_string(val.date_end);

                            var timez = Date.parse(val.date_end);
                            var timestamp = timez - start;

                            res.data[key]['timestamp'] = timestamp

                            res.data[key]['count_down_round'] = val.round_countdown

                            var btn = 'btn-info'

                            if(val.pause=='start'){
                                btn = 'btn-danger'
                            }
                            var dis_pause = '';

                            if(val.status=='finish'){
                                dis_pause = 'disabled';
                            }

                            var btn_pause = '<button '+dis_pause+' class="btn btn-sm btn-rounded l-5 '+btn+' btn_pause btn-w" id="btn_pause_'+val._id+'" data-id="'+val._id+'" data-key="'+key+'">'+val.pause+'</button>';

                            var reset = '<button class="btn btn-sm btn-rounded l-5 btn-danger btn_reset btn-w" id="btn_reset_'+val._id+'" data-id="'+val._id+'" data-key="'+key+'">reset</button>';

                            var btn_setting = '<button class="btn btn-secondary btn-sm btn-rounded l-5 btn_setting btn-w" id="btn_setting_'+val._id+'" data-id="'+val._id+'" data-key="'+key+'">History</button>';

                            $('#pickle tbody').append('<tr><td>'+(key+1)+'</td><td>'+val.name+'</td><td id="status_'+val._id+'">'+fuper(val.status)+'</td><td class="time-start" data-time="'+start+'">'+start+'</td><td>'+val.round_max+'</td><td id="round_slug_'+val._id+'">'+val.round_slug+'</td><td class="count_down_start" id="count-start-'+val._id+'">-</td><td class="count_down" id="count-down-'+val._id+'">-</td><td>'+btn_pause+reset+btn_setting+'</td></tr>')

                            now++
                        });

                        products = res.data;
                        start_count = true

                    }else{
                        sweetAlert("Oops...", data.message, "error");
                    }
                },
                error: function (xhr, status, error) {
                    alert_error(xhr,error)
                },
            });
        }





